/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	（学習終了サーブレット）クラス
//			変更履歴
//				2004.01.08	新規作成	五木田　泰史
//
package jp.co.ntt.lms.lo;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.ntt.lms.xmo.Environment;
import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * タイトル:		EndLearnServlet
 * 説明:			学習の終了制御を行うServletクラス
 * @author		Y.Gokita
 * @version		1.0
 * 修正履歴		2004.01.08 新規作成
 */
public class EndLearnServlet extends HttpServlet
	implements LoPropertyDef
{

	// エラーメッセージ
	private static final String ERR_MESSAGE_01 = "戻り先が指定されておりません。";

	// エラー画面
	private static final String LEARN_ERR_URL = "/view/xmo/Message/Messageerror.vm?message=";

	public EndLearnServlet() {
	}

	/**
	 * 端末からのＧＥＴ要求を処理するメソッド<br>
	 * @param HttpServletRequest	ＨＴＴＰリクエスト
	 * @param HttpServletResponse	ＨＴＴＰレスポンス
	 * @return void
	 * @exception javax.servlet.ServletException	サーブレット例外
	 * @exception java.io.IOException				入出力例外
	 */
	public void doGet(HttpServletRequest request,HttpServletResponse response)
			throws ServletException, IOException
	{
		// リクエスト処理を呼び出します
		this.doRequest(request, response);
	}

	/**
	 * 端末からのＰＯＳＴ要求を処理するメソッド<br>
	 * @param HttpServletRequest	ＨＴＴＰリクエスト
	 * @param HttpServletResponse	ＨＴＴＰレスポンス
	 * @return void
	 * @exception javax.servlet.ServletException	サーブレット例外
	 * @exception java.io.IOException				入出力例外
	 */
	public void doPost(HttpServletRequest request,HttpServletResponse response)
			throws ServletException, IOException
	{
		// リクエスト処理を呼び出します
		this.doRequest(request, response);
	}

	/**
	 * 端末からの要求を処理するメソッド<br>
	 * @param HttpServletRequest	ＨＴＴＰリクエスト
	 * @param HttpServletResponse	ＨＴＴＰレスポンス
	 * @return void
	 */
	private void doRequest(
		HttpServletRequest request, HttpServletResponse response)
	{
		// request要求からLO情報を取得します。
		String  strUserID      = request.getParameter( USER );
		String  strSessionID = request.getParameter( SESSIONID );
		String  strMatID = request.getParameter( MATURL );

		Hashtable htbParam = new Hashtable();
		Enumeration en = request.getParameterNames();
		while( en.hasMoreElements() ) {
			String strKey = (String)en.nextElement();
			String strValue = request.getParameter( strKey );
			// ハッシュに格納
			htbParam.put( strKey, strValue );
		}

		// 学習セッションファイル読込み処理
		String strLoID = "";
		// 学習対象ＬＯのLOID
		String strTargetLOID = "";
		String strLoType = "";
		String strReturnURL = "";
		try
		{
			LearnSession objLs = new LearnSession();
			objLs.setUserID(strUserID);
			if( strSessionID != null ) {
				objLs.setSessionID(strSessionID);
			}
			else if( strMatID != null ) {
				objLs.setSessionID(strMatID);
			}
			objLs.setLoType(strLoType);
			objLs.load();
			strLoID = objLs.getLoID();
			// 学習対象ＬＯのLOIDを取得
			strTargetLOID = objLs.getTargetLOID();
			strLoType = objLs.getLoType();
			strReturnURL = objLs.getReturnURL();
			htbParam.put( LOID, strLoID );
			// 学習対象ＬＯのLOIDのパラメータ設定
			htbParam.put( TARGETLOID, strTargetLOID );
			htbParam.put( LO_TYPE, strLoType );
			objLs.delete();
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}

		try {

			// LO種別が指定されていない場合以下の処理を行わない
			if( strLoType != null ) {

				// サーバ名称の取得
				Environment objEnv = new Environment();
				String strServerName = objEnv.getLoServerName();
				// Loクライアントのインスタンスを生成します
				LoTopClient objLoCli = new LoTopClient(strServerName, strLoType);

				// Loクライアントの学習開始メソッドを実行します。
				// 　   正否（true：正常、false：異常）
				// パラメータの設定
				objLoCli.setParam( htbParam );
				boolean bLearn = objLoCli.endLearn();
				if ( bLearn == false )
				{
					DebugLog.write( this.getClass(), "学習終了確認 = エラー", DebugLog.ROW );

					// 学習を開始できない場合は、エラー画面へのリダイレクト処理を行います。
					try
					{
						String strSystemUrl = objEnv.getSystemURL();						
						String strErrUrl = objLoCli.getLearnErrorURL();						
						strReturnURL = strSystemUrl + strErrUrl;							
						response.sendRedirect(strReturnURL);								
					}
					catch(IOException ie)
					{
						DebugLog.write( this.getClass(), "エラーページリダイレクト失敗", DebugLog.HIGHT );
					}
					return;																	
				}
				else
				{
					DebugLog.write( this.getClass(), "学習終了確認 = OK", DebugLog.ROW );
				}
			}

			// 戻りURLがNULLかつ空白ならば
			if (strReturnURL == null || strReturnURL.equals(""))
			{
				// 戻り先URLが指定されていない場合、
				// エラー画面への戻りURL設定を行います
				Environment objEnv = new Environment();										
				String strSystemUrl = objEnv.getSystemURL();								
				strReturnURL = strSystemUrl + LEARN_ERR_URL + ERR_MESSAGE_01;				
				try
				{
					response.sendRedirect(strReturnURL);									
				}
				catch(IOException ie)
				{
					DebugLog.write( this.getClass(), "エラーページリダイレクト失敗", DebugLog.HIGHT );
				}
				return;																		
			}

			DebugLog.write( this.getClass(), "ReturnURL = " + strReturnURL, DebugLog.ROW );

			// 閉じる処理をするJavaScript生成
			String strHtml = createHtml();
			PrintWriter out = response.getWriter();
			out.println( strHtml );

			return;
		}
		catch( Exception e )
		{
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			// 上記以外に失敗（システム障害）した場合、Exception例外をスローする。
			// キャッチしたら、メッセージを取得する。
			String  strErrMessage = e.getMessage();
			if (strErrMessage == "")
			{
				strErrMessage = "例外が発生していますが、該当するメッセージがありません。";
			}
			// エラー画面へのリダイレクト処理を行います
			try {
				Environment objEnv = new Environment();
				String strSystemUrl = objEnv.getSystemURL();
				String strErrURL = strSystemUrl + LEARN_ERR_URL + strErrMessage;
				try
				{
					response.sendRedirect( strErrURL );
				}
				catch(IOException ie)
				{
					DebugLog.write( this.getClass(), "エラーページリダイレクト失敗", DebugLog.HIGHT );
				}
			}
			catch( Exception ex ) {
			}
			return;
		}
	}

	/**
	 * 閉じる画面を作成します
	 */
	private String createHtml() {
		StringBuffer sb = new StringBuffer();

		sb.append( "<HTML>\n" );
		sb.append( "<HEAD>\n" );
		sb.append( "<TITLE>LearnEnd</TITLE>\n" );
		sb.append( "</HEAD>\n" );
		sb.append( "<script language=JavaScript>\n" );
		sb.append( "<!--\n" );
		sb.append( "	function learnClose() {\n" );
		sb.append( "		window.close();\n" );
		sb.append( "	}\n" );
		sb.append( "-->\n" );
		sb.append( "</script>\n" );
		sb.append( "<body onload=\"learnClose()\">\n" );
		sb.append( "\n" );
		sb.append( "</body>\n" );
		sb.append( "</HTML>\n" );

		return sb.toString();
	}
}

